/* **********************************************************************
 * Crear la ventana principal de la aplicacin.
 * ********************************************************************** */
#include <gtk/gtk.h>
#include "idpl.h"

/* **********************************************************************
 * ********************************************************************** */
void on_ok_button_file_selection_clicked (GtkWidget *widget, gpointer data)
{
    GtkWidget *fsel = (GtkWidget*)data;
    image_t* image;
    /* este gchar lo elimina el selector de ficheros cuando se cierra ???? */
    const gchar *file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION(fsel));

    if (!(image = idp_image_new_from_file (file_name)))
	g_print ("Error al cargar imagen: formato no valido\n");
    else
	idp_window_with_image (image);
}
/* **********************************************************************
 * Boton abrir de la aplicacion principal.
 * ********************************************************************** */
void on_button_open_file_clicked (GtkWidget *widget, GtkWidget **data)
{
    GtkWidget *fsel;	/* selector de ficheros */

    fsel = gtk_file_selection_new ("Seleccione la imagen");
    gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(fsel));
    gtk_widget_show (fsel);

    g_signal_connect (G_OBJECT(GTK_FILE_SELECTION(fsel)->ok_button), "clicked", G_CALLBACK(on_ok_button_file_selection_clicked), fsel);

   /* Tanto al pulsar OK como CANCELAR cerramos el selector de ficheros */
   g_signal_connect_swapped (G_OBJECT(GTK_FILE_SELECTION(fsel)->ok_button), "clicked", G_CALLBACK(gtk_widget_destroy), fsel);
   g_signal_connect_swapped (G_OBJECT(GTK_FILE_SELECTION(fsel)->cancel_button), "clicked", G_CALLBACK(gtk_widget_destroy), fsel);

}
/* **********************************************************************
 * Crear la ventana princial de nuestra aplicacion. De momento solo
 * tiene un boton. El boton para abrir imagenes.
 * ********************************************************************** */
void create_main_window (void)
{
    GtkWidget *window;
    GtkWidget *button, *label, *vbox;


    /* Ventana Genrica */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (gtk_main_quit), NULL);
    gtk_window_set_title (GTK_WINDOW (window), "Imagen Digital Processing");
    //gtk_window_set_default_size (GTK_WINDOW(window), 300, 100);

    /* boton abrir fichero */
    button = gtk_button_new_with_mnemonic ("_Abrir Imagen");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (on_button_open_file_clicked), NULL);

    /* vbox */
    vbox = gtk_vbox_new (FALSE, 8);
    gtk_box_pack_start (GTK_BOX(vbox), button, TRUE, TRUE, 0);

    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_widget_show_all (window);
}
/* **********************************************************************
 * Programa principal.
 * ********************************************************************** */
int main (int argc, char *argv[])
{
    gtk_init (&argc, &argv);
    create_main_window ();
    /*
    image_t * image = idp_image_new_from_file ("imagen/03.jpeg");
    idp_window_with_image (image);
    //idp_window_with_image (idp_image_new_horizontal_mirror (image));
    //idp_window_with_image (idp_image_new_vertical_mirror (image));
    //idp_window_with_image (idp_image_new_rotation_90 (image));
    //idp_window_with_image (idp_image_new_resize (image, 100, 100 , 1));
    idp_window_with_image (idp_image_new_rotation (image, -36, 1));
    */
    gtk_main ();
}
